From: =?utf-8?b?5L6d5LqR?= <lilydjwg@gmail.com>
Date: Thu, 10 Mar 2016 17:50:30 +0800
Subject: apply patches from Arch Linux

---
 psshlib/askpass_server.py | 2 +-
 psshlib/manager.py        | 2 ++
 2 files changed, 3 insertions(+), 1 deletion(-)

diff --git a/psshlib/askpass_server.py b/psshlib/askpass_server.py
index 4293164..3a2b0e5 100644
--- a/psshlib/askpass_server.py
+++ b/psshlib/askpass_server.py
@@ -69,7 +69,7 @@ class PasswordServer(object):
         buffer = self.buffermap[fd]
         conn = self.socketmap[fd]
         try:
-            bytes_written = conn.send(buffer)
+            bytes_written = conn.send(buffer.encode())
         except socket.error:
             _, e, _ = sys.exc_info()
             number = e.args[0]
diff --git a/psshlib/manager.py b/psshlib/manager.py
index 9b5686d..5d61d88 100644
--- a/psshlib/manager.py
+++ b/psshlib/manager.py
@@ -2,6 +2,7 @@
 
 from errno import EINTR
 import os
+import fcntl
 import select
 import signal
 import sys
@@ -209,6 +210,7 @@ class IOMap(object):
 
         # Setup the wakeup file descriptor to avoid hanging on lost signals.
         wakeup_readfd, wakeup_writefd = os.pipe()
+        fcntl.fcntl(wakeup_writefd, fcntl.F_SETFL, os.O_NONBLOCK)
         self.register_read(wakeup_readfd, self.wakeup_handler)
         # TODO: remove test when we stop supporting Python <2.5
         if hasattr(signal, 'set_wakeup_fd'):
